#ifndef _IMU_SERIAL_HPP_
#define _IMU_SERIAL_HPP_

#include <string>
#include <glm/glm.hpp>
#include <glm/gtc/quaternion.hpp>
#include <mutex>
#include <thread>

class ImuSerial
{
	public:
		ImuSerial(const std::string &serial_device, unsigned int baud);
		~ImuSerial();
		void start();
		void stop();

		glm::quat get_quaternion();
		const glm::mat4 get_rot_matrix();

	private:
		std::string serial_device;
		unsigned int baud;
		std::mutex quat_mutex;
		glm::quat quaternion;
		std::thread worker;
		int stop_flag;
		int fd;
		friend void working_thread(ImuSerial *self);
		friend void update_quaternion(ImuSerial *self, const glm::quat &quat);

};


#endif /* _IMU_SERIAL_HPP_ */
